

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>d2o.utils.logger &mdash; d2o Python Library 1.0 documentation</title>
  

  
  

  

  
  
    

  

  
  
    <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
  

  

  
    <link rel="top" title="d2o Python Library 1.0 documentation" href="../../../index.html"/>
        <link rel="up" title="Module code" href="../../index.html"/> 

  
  <script src="../../../_static/js/modernizr.min.js"></script>

</head>

<body class="wy-body-for-nav" role="document">

  <div class="wy-grid-for-nav">

    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search">
          

          
            <a href="../../../index.html" class="icon icon-home"> d2o Python Library
          

          
          </a>

          
            
            
              <div class="version">
                1.0
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
                <ul class="simple">
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
        <a href="../../../index.html">d2o Python Library</a>
      </nav>


      
      <div class="wy-nav-content">
        <div class="rst-content">
          





<div role="navigation" aria-label="breadcrumbs navigation">
  <ul class="wy-breadcrumbs">
    <li><a href="../../../index.html">Docs</a> &raquo;</li>
      
          <li><a href="../../index.html">Module code</a> &raquo;</li>
      
    <li>d2o.utils.logger</li>
      <li class="wy-breadcrumbs-aside">
        
          
        
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <h1>Source code for d2o.utils.logger</h1><div class="highlight"><pre>
<span></span><span class="c1"># -*- encoding: utf-8 -*-</span>
<span class="c1">#</span>
<span class="c1"># Copyright (c) 2016 Chronos AS</span>
<span class="c1">#</span>
<span class="c1"># Authors: Fredrik Stormo, Stefan Remman</span>
<span class="c1"># Contact: kjetil.karlsen@chronosit.no</span>

<span class="kn">from</span> <span class="nn">__future__</span> <span class="kn">import</span> <span class="n">print_function</span>
<span class="kn">from</span> <span class="nn">datetime</span> <span class="kn">import</span> <span class="n">datetime</span>
<span class="kn">from</span> <span class="nn">d2o.utils</span> <span class="kn">import</span> <span class="n">systools</span>
<span class="kn">from</span> <span class="nn">d2o.utils.handlers</span> <span class="kn">import</span> <span class="n">ExceptionHandler</span>
<span class="kn">import</span> <span class="nn">inspect</span>
<span class="kn">import</span> <span class="nn">shutil</span>
<span class="kn">import</span> <span class="nn">sys</span>
<span class="kn">import</span> <span class="nn">os</span>

<span class="k">class</span> <span class="nc">__COLORS</span><span class="p">:</span>
    <span class="n">BLUE</span> <span class="o">=</span> <span class="s1">&#39;</span><span class="se">\033</span><span class="s1">[94m&#39;</span>
    <span class="n">GREEN</span> <span class="o">=</span> <span class="s1">&#39;</span><span class="se">\033</span><span class="s1">[92m&#39;</span>
    <span class="n">YELLOW</span> <span class="o">=</span> <span class="s1">&#39;</span><span class="se">\033</span><span class="s1">[93m&#39;</span>
    <span class="n">RED</span> <span class="o">=</span> <span class="s1">&#39;</span><span class="se">\033</span><span class="s1">[91m&#39;</span>
    <span class="n">ENDC</span> <span class="o">=</span> <span class="s1">&#39;</span><span class="se">\033</span><span class="s1">[0m&#39;</span>

<span class="n">__LOG_VERBOSITY</span>   <span class="o">=</span> <span class="s2">&quot;info&quot;</span>
<span class="n">__PRINT_VERBOSITY</span> <span class="o">=</span> <span class="s2">&quot;warning&quot;</span>
<span class="n">__SHOW_INSPECTION</span> <span class="o">=</span> <span class="bp">True</span>

<span class="n">__DO_LOG</span> <span class="o">=</span> <span class="bp">False</span>
<span class="n">__SHOW_COLORS</span> <span class="o">=</span> <span class="bp">False</span>

<span class="n">__LOGDIR</span> <span class="o">=</span> <span class="bp">None</span>

<span class="n">__VERBOSITY_LEVELS</span> <span class="o">=</span> <span class="p">[</span><span class="s2">&quot;silent&quot;</span><span class="p">,</span><span class="s2">&quot;error&quot;</span><span class="p">,</span><span class="s2">&quot;warning&quot;</span><span class="p">,</span><span class="s2">&quot;info&quot;</span><span class="p">,</span><span class="s2">&quot;debug&quot;</span><span class="p">]</span>
<span class="n">__VERBOSITY_MAPPING</span> <span class="o">=</span> <span class="p">{</span>
  <span class="s2">&quot;silent&quot;</span>  <span class="p">:</span><span class="n">__VERBOSITY_LEVELS</span><span class="p">[:</span><span class="mi">1</span><span class="p">],</span>
  <span class="s2">&quot;error&quot;</span>   <span class="p">:</span><span class="n">__VERBOSITY_LEVELS</span><span class="p">[:</span><span class="mi">2</span><span class="p">],</span>
  <span class="s2">&quot;warning&quot;</span> <span class="p">:</span><span class="n">__VERBOSITY_LEVELS</span><span class="p">[:</span><span class="mi">3</span><span class="p">],</span>
  <span class="s2">&quot;info&quot;</span>    <span class="p">:</span><span class="n">__VERBOSITY_LEVELS</span><span class="p">[:</span><span class="mi">4</span><span class="p">],</span>
  <span class="s2">&quot;debug&quot;</span>   <span class="p">:</span><span class="n">__VERBOSITY_LEVELS</span><span class="p">[:</span><span class="mi">5</span><span class="p">]</span>
  <span class="p">}</span>

<span class="n">__MAX_LOG_SIZE</span> <span class="o">=</span> <span class="mi">16000000</span> <span class="c1"># bytes (16 megabytes)</span>

<div class="viewcode-block" id="enable_inspection"><a class="viewcode-back" href="../../../d2o.utils.html#d2o.utils.logger.enable_inspection">[docs]</a><span class="k">def</span> <span class="nf">enable_inspection</span><span class="p">():</span>
  <span class="k">global</span> <span class="n">__SHOW_INSPECTION</span>
  <span class="n">__SHOW_INSPECTION</span> <span class="o">=</span> <span class="bp">True</span></div>

<div class="viewcode-block" id="disable_inspection"><a class="viewcode-back" href="../../../d2o.utils.html#d2o.utils.logger.disable_inspection">[docs]</a><span class="k">def</span> <span class="nf">disable_inspection</span><span class="p">():</span>
  <span class="k">global</span> <span class="n">__SHOW_INSPECTION</span>
  <span class="n">__SHOW_INSPECTION</span> <span class="o">=</span> <span class="bp">False</span></div>

<div class="viewcode-block" id="enable_colors"><a class="viewcode-back" href="../../../d2o.utils.html#d2o.utils.logger.enable_colors">[docs]</a><span class="k">def</span> <span class="nf">enable_colors</span><span class="p">():</span>
  <span class="k">if</span> <span class="p">(</span><span class="n">systools</span><span class="o">.</span><span class="n">on_windows</span><span class="p">()):</span>
    <span class="k">return</span>

  <span class="k">global</span> <span class="n">__SHOW_COLORS</span>
  <span class="n">__SHOW_COLORS</span> <span class="o">=</span> <span class="bp">True</span></div>

<div class="viewcode-block" id="disable_colors"><a class="viewcode-back" href="../../../d2o.utils.html#d2o.utils.logger.disable_colors">[docs]</a><span class="k">def</span> <span class="nf">disable_colors</span><span class="p">():</span>
  <span class="k">global</span> <span class="n">__SHOW_COLORS</span>
  <span class="n">__SHOW_COLORS</span> <span class="o">=</span> <span class="bp">False</span></div>

<div class="viewcode-block" id="enable_logging"><a class="viewcode-back" href="../../../d2o.utils.html#d2o.utils.logger.enable_logging">[docs]</a><span class="k">def</span> <span class="nf">enable_logging</span><span class="p">():</span>
  <span class="k">global</span> <span class="n">__DO_LOG</span>
  <span class="n">__DO_LOG</span> <span class="o">=</span> <span class="bp">True</span></div>

<div class="viewcode-block" id="disable_logging"><a class="viewcode-back" href="../../../d2o.utils.html#d2o.utils.logger.disable_logging">[docs]</a><span class="k">def</span> <span class="nf">disable_logging</span><span class="p">():</span>
  <span class="k">global</span> <span class="n">__DO_LOG</span>
  <span class="n">__DO_LOG</span> <span class="o">=</span> <span class="bp">False</span></div>

<div class="viewcode-block" id="set_print_verbosity"><a class="viewcode-back" href="../../../d2o.utils.html#d2o.utils.logger.set_print_verbosity">[docs]</a><span class="k">def</span> <span class="nf">set_print_verbosity</span><span class="p">(</span><span class="n">v</span><span class="p">):</span>
  <span class="k">global</span> <span class="n">__PRINT_VERBOSITY</span>
  <span class="k">if</span> <span class="p">(</span><span class="nb">isinstance</span><span class="p">(</span><span class="n">v</span><span class="p">,</span><span class="nb">basestring</span><span class="p">)):</span>
    <span class="n">__PRINT_VERBOSITY</span> <span class="o">=</span> <span class="n">v</span>
  <span class="k">else</span><span class="p">:</span>
    <span class="n">__PRINT_VERBOSITY</span> <span class="o">=</span> <span class="n">__VERBOSITY_LEVELS</span><span class="p">[</span><span class="n">v</span><span class="p">]</span></div>

<div class="viewcode-block" id="set_log_verbosity"><a class="viewcode-back" href="../../../d2o.utils.html#d2o.utils.logger.set_log_verbosity">[docs]</a><span class="k">def</span> <span class="nf">set_log_verbosity</span><span class="p">(</span><span class="n">v</span><span class="p">):</span>
  <span class="k">global</span> <span class="n">__LOG_VERBOSITY</span>
  <span class="k">if</span> <span class="p">(</span><span class="nb">isinstance</span><span class="p">(</span><span class="n">v</span><span class="p">,</span><span class="nb">basestring</span><span class="p">)):</span>
    <span class="n">__LOG_VERBOSITY</span> <span class="o">=</span> <span class="n">v</span>
  <span class="k">else</span><span class="p">:</span>
    <span class="n">__LOG_VERBOSITY</span> <span class="o">=</span> <span class="n">__VERBOSITY_LEVELS</span><span class="p">[</span><span class="n">v</span><span class="p">]</span></div>

<div class="viewcode-block" id="set_logdir"><a class="viewcode-back" href="../../../d2o.utils.html#d2o.utils.logger.set_logdir">[docs]</a><span class="k">def</span> <span class="nf">set_logdir</span><span class="p">(</span><span class="n">path</span><span class="p">):</span>
  <span class="k">global</span> <span class="n">__LOGDIR</span>
  <span class="k">if</span> <span class="ow">not</span> <span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">exists</span><span class="p">(</span><span class="n">path</span><span class="p">)):</span>
    <span class="n">systools</span><span class="o">.</span><span class="n">makedirs</span><span class="p">(</span><span class="n">path</span><span class="p">)</span>

  <span class="k">if</span> <span class="p">(</span><span class="n">path</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span> <span class="o">!=</span> <span class="n">os</span><span class="o">.</span><span class="n">sep</span><span class="p">):</span>
    <span class="n">path</span> <span class="o">+=</span> <span class="n">os</span><span class="o">.</span><span class="n">sep</span>

  <span class="n">__LOGDIR</span> <span class="o">=</span> <span class="n">path</span></div>

<span class="k">def</span> <span class="nf">__format_message</span><span class="p">(</span><span class="n">message</span><span class="p">):</span>
  <span class="k">if</span> <span class="p">(</span><span class="nb">isinstance</span><span class="p">(</span><span class="n">message</span><span class="p">,</span> <span class="n">ExceptionHandler</span><span class="p">)):</span>
    <span class="n">message</span> <span class="o">=</span> <span class="s1">u&#39;</span><span class="si">%s</span><span class="s1">&#39;</span> <span class="o">%</span> <span class="nb">str</span><span class="p">(</span><span class="n">message</span><span class="p">)</span>
  <span class="n">message</span> <span class="o">=</span> <span class="n">message</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="s1">&#39;</span><span class="se">\n</span><span class="s1">&#39;</span><span class="p">,</span> <span class="s1">&#39;</span><span class="se">\n</span><span class="s1">    |&#39;</span><span class="p">)</span>
  <span class="k">return</span> <span class="n">message</span>

<span class="k">def</span> <span class="nf">__caller_string</span><span class="p">():</span>
  <span class="k">if</span> <span class="p">(</span><span class="ow">not</span> <span class="n">__SHOW_INSPECTION</span><span class="p">):</span>
    <span class="k">return</span> <span class="s2">&quot; &quot;</span>

  <span class="n">caller</span> <span class="o">=</span> <span class="n">inspect</span><span class="o">.</span><span class="n">getouterframes</span><span class="p">(</span><span class="n">inspect</span><span class="o">.</span><span class="n">currentframe</span><span class="p">(),</span> <span class="mi">2</span><span class="p">)[</span><span class="o">-</span><span class="mi">1</span><span class="p">][</span><span class="mi">1</span><span class="p">]</span>
  <span class="n">s</span> <span class="o">=</span> <span class="s1">&#39; </span><span class="si">%s</span><span class="s1"> &#39;</span> <span class="o">%</span> <span class="n">caller</span>
  <span class="k">return</span> <span class="n">s</span>

<div class="viewcode-block" id="print_message"><a class="viewcode-back" href="../../../d2o.utils.html#d2o.utils.logger.print_message">[docs]</a><span class="k">def</span> <span class="nf">print_message</span><span class="p">(</span><span class="n">message</span><span class="p">,</span> <span class="n">verbosity_level</span><span class="p">):</span>
  <span class="k">if</span> <span class="p">(</span><span class="n">verbosity_level</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">__VERBOSITY_MAPPING</span><span class="p">[</span><span class="n">__PRINT_VERBOSITY</span><span class="p">]):</span>
    <span class="k">return</span>
  <span class="k">print</span><span class="p">(</span><span class="n">message</span><span class="p">)</span></div>

<div class="viewcode-block" id="log_message"><a class="viewcode-back" href="../../../d2o.utils.html#d2o.utils.logger.log_message">[docs]</a><span class="k">def</span> <span class="nf">log_message</span><span class="p">(</span><span class="n">message</span><span class="p">,</span> <span class="n">verbosity_level</span><span class="p">):</span>
  <span class="k">if</span> <span class="ow">not</span> <span class="p">(</span><span class="n">__DO_LOG</span><span class="p">):</span>
    <span class="k">return</span>

  <span class="k">if</span> <span class="p">(</span><span class="n">verbosity_level</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">__VERBOSITY_MAPPING</span><span class="p">[</span><span class="n">__LOG_VERBOSITY</span><span class="p">]):</span>
    <span class="k">return</span>

  <span class="k">global</span> <span class="n">__LOGDIR</span>
  <span class="k">if</span> <span class="p">(</span><span class="n">__LOGDIR</span> <span class="o">==</span> <span class="bp">None</span><span class="p">):</span>
    <span class="n">__LOGDIR</span> <span class="o">=</span> <span class="n">systools</span><span class="o">.</span><span class="n">maindir_realpath</span><span class="p">()</span> <span class="o">+</span> <span class="s2">&quot;logs&quot;</span> <span class="o">+</span> <span class="n">os</span><span class="o">.</span><span class="n">sep</span>

  <span class="n">systools</span><span class="o">.</span><span class="n">makedirs</span><span class="p">(</span><span class="n">__LOGDIR</span><span class="p">)</span>
  <span class="n">logfile_path</span> <span class="o">=</span> <span class="n">__LOGDIR</span> <span class="o">+</span> <span class="s2">&quot;latest.txt&quot;</span>

  <span class="k">if</span> <span class="p">(</span><span class="n">systools</span><span class="o">.</span><span class="n">file_exists</span><span class="p">(</span><span class="n">logfile_path</span><span class="p">)):</span>
    <span class="k">if</span> <span class="p">(</span><span class="n">systools</span><span class="o">.</span><span class="n">file_size</span><span class="p">(</span><span class="n">logfile_path</span><span class="p">)</span> <span class="o">&gt;</span> <span class="n">__MAX_LOG_SIZE</span><span class="p">):</span>
      <span class="n">destfile</span> <span class="o">=</span> <span class="n">__LOGDIR</span> <span class="o">+</span> <span class="p">(</span><span class="s2">&quot;</span><span class="si">%s</span><span class="s2">.txt&quot;</span> <span class="o">%</span> <span class="n">systools</span><span class="o">.</span><span class="n">now_string</span><span class="p">(</span><span class="n">systools</span><span class="o">.</span><span class="n">ISO_DATETIME_FORMAT_FSAFE</span><span class="p">))</span>
      <span class="n">shutil</span><span class="o">.</span><span class="n">copy</span><span class="p">(</span><span class="n">logfile_path</span><span class="p">,</span> <span class="n">destfile</span><span class="p">)</span>
      <span class="n">logfile</span> <span class="o">=</span> <span class="nb">open</span><span class="p">(</span><span class="n">logfile_path</span><span class="p">,</span> <span class="s1">&#39;w&#39;</span><span class="p">)</span>
    <span class="k">else</span><span class="p">:</span>
      <span class="n">logfile</span> <span class="o">=</span> <span class="nb">open</span><span class="p">(</span><span class="n">logfile_path</span><span class="p">,</span> <span class="s1">&#39;a&#39;</span><span class="p">)</span>
  <span class="k">else</span><span class="p">:</span>
    <span class="n">logfile</span> <span class="o">=</span> <span class="nb">open</span><span class="p">(</span><span class="n">logfile_path</span><span class="p">,</span> <span class="s1">&#39;w&#39;</span><span class="p">)</span>
  <span class="k">print</span><span class="p">(</span><span class="n">message</span><span class="p">,</span> <span class="nb">file</span><span class="o">=</span><span class="n">logfile</span><span class="p">)</span>
  <span class="n">logfile</span><span class="o">.</span><span class="n">close</span><span class="p">()</span></div>

<div class="viewcode-block" id="debug"><a class="viewcode-back" href="../../../d2o.utils.html#d2o.utils.logger.debug">[docs]</a><span class="k">def</span> <span class="nf">debug</span><span class="p">(</span><span class="n">message</span><span class="p">):</span>
  <span class="n">message</span> <span class="o">=</span> <span class="n">__format_message</span><span class="p">(</span><span class="n">message</span><span class="p">)</span>

  <span class="n">os</span> <span class="o">=</span> <span class="s2">&quot;[</span><span class="si">%s%s</span><span class="s2">DEBUG] </span><span class="si">%s</span><span class="s2">&quot;</span> <span class="o">%</span> <span class="p">(</span><span class="n">systools</span><span class="o">.</span><span class="n">now_string</span><span class="p">(),</span> <span class="n">__caller_string</span><span class="p">(),</span> <span class="n">message</span><span class="p">)</span>
  <span class="n">ls</span> <span class="o">=</span> <span class="n">os</span>

  <span class="n">print_message</span><span class="p">(</span><span class="n">os</span><span class="p">,</span> <span class="s2">&quot;debug&quot;</span><span class="p">)</span>
  <span class="n">log_message</span><span class="p">(</span><span class="n">ls</span><span class="p">,</span> <span class="s2">&quot;debug&quot;</span><span class="p">)</span></div>

<div class="viewcode-block" id="info"><a class="viewcode-back" href="../../../d2o.utils.html#d2o.utils.logger.info">[docs]</a><span class="k">def</span> <span class="nf">info</span><span class="p">(</span><span class="n">message</span><span class="p">):</span>
  <span class="n">message</span> <span class="o">=</span> <span class="n">__format_message</span><span class="p">(</span><span class="n">message</span><span class="p">)</span>

  <span class="n">os</span> <span class="o">=</span> <span class="s2">&quot;[</span><span class="si">%s%s</span><span class="s2">INFO] </span><span class="si">%s</span><span class="s2">&quot;</span> <span class="o">%</span> <span class="p">(</span><span class="n">systools</span><span class="o">.</span><span class="n">now_string</span><span class="p">(),</span> <span class="n">__caller_string</span><span class="p">(),</span> <span class="n">message</span><span class="p">)</span>
  <span class="n">ls</span> <span class="o">=</span> <span class="n">os</span>
  <span class="n">print_message</span><span class="p">(</span><span class="n">os</span><span class="p">,</span> <span class="s2">&quot;info&quot;</span><span class="p">)</span>
  <span class="n">log_message</span><span class="p">(</span><span class="n">ls</span><span class="p">,</span> <span class="s2">&quot;info&quot;</span><span class="p">)</span></div>

<div class="viewcode-block" id="success"><a class="viewcode-back" href="../../../d2o.utils.html#d2o.utils.logger.success">[docs]</a><span class="k">def</span> <span class="nf">success</span><span class="p">(</span><span class="n">message</span><span class="p">):</span>
  <span class="n">message</span> <span class="o">=</span> <span class="n">__format_message</span><span class="p">(</span><span class="n">message</span><span class="p">)</span>

  <span class="n">sc</span> <span class="o">=</span> <span class="n">__COLORS</span><span class="o">.</span><span class="n">GREEN</span> <span class="k">if</span> <span class="p">(</span><span class="n">__SHOW_COLORS</span><span class="p">)</span> <span class="k">else</span> <span class="s1">&#39;&#39;</span>
  <span class="n">ec</span> <span class="o">=</span> <span class="n">__COLORS</span><span class="o">.</span><span class="n">ENDC</span> <span class="k">if</span> <span class="p">(</span><span class="n">__SHOW_COLORS</span><span class="p">)</span> <span class="k">else</span> <span class="s1">&#39;&#39;</span>

  <span class="n">os</span> <span class="o">=</span> <span class="s2">&quot;</span><span class="si">%s</span><span class="s2">[</span><span class="si">%s%s</span><span class="s2">SUCCESS] </span><span class="si">%s%s</span><span class="s2">&quot;</span> <span class="o">%</span> <span class="p">(</span><span class="n">sc</span><span class="p">,</span> <span class="n">systools</span><span class="o">.</span><span class="n">now_string</span><span class="p">(),</span> <span class="n">__caller_string</span><span class="p">(),</span> <span class="n">message</span><span class="p">,</span> <span class="n">ec</span><span class="p">)</span>
  <span class="n">ls</span> <span class="o">=</span> <span class="s2">&quot;[</span><span class="si">%s%s</span><span class="s2">SUCCESS] </span><span class="si">%s</span><span class="s2">&quot;</span> <span class="o">%</span> <span class="p">(</span><span class="n">systools</span><span class="o">.</span><span class="n">now_string</span><span class="p">(),</span> <span class="n">__caller_string</span><span class="p">(),</span> <span class="n">message</span><span class="p">)</span>

  <span class="n">print_message</span><span class="p">(</span><span class="n">os</span><span class="p">,</span> <span class="s2">&quot;info&quot;</span><span class="p">)</span>
  <span class="n">log_message</span><span class="p">(</span><span class="n">ls</span><span class="p">,</span> <span class="s2">&quot;info&quot;</span><span class="p">)</span></div>

<div class="viewcode-block" id="warning"><a class="viewcode-back" href="../../../d2o.utils.html#d2o.utils.logger.warning">[docs]</a><span class="k">def</span> <span class="nf">warning</span><span class="p">(</span><span class="n">message</span><span class="p">):</span>
  <span class="n">message</span> <span class="o">=</span> <span class="n">__format_message</span><span class="p">(</span><span class="n">message</span><span class="p">)</span>

  <span class="n">sc</span> <span class="o">=</span> <span class="n">__COLORS</span><span class="o">.</span><span class="n">YELLOW</span> <span class="k">if</span> <span class="p">(</span><span class="n">__SHOW_COLORS</span><span class="p">)</span> <span class="k">else</span> <span class="s1">&#39;&#39;</span>
  <span class="n">ec</span> <span class="o">=</span> <span class="n">__COLORS</span><span class="o">.</span><span class="n">ENDC</span> <span class="k">if</span> <span class="p">(</span><span class="n">__SHOW_COLORS</span><span class="p">)</span> <span class="k">else</span> <span class="s1">&#39;&#39;</span>

  <span class="n">os</span> <span class="o">=</span> <span class="s2">&quot;</span><span class="si">%s</span><span class="s2">[</span><span class="si">%s%s</span><span class="s2">WARNING] </span><span class="si">%s%s</span><span class="s2">&quot;</span> <span class="o">%</span> <span class="p">(</span><span class="n">sc</span><span class="p">,</span> <span class="n">systools</span><span class="o">.</span><span class="n">now_string</span><span class="p">(),</span> <span class="n">__caller_string</span><span class="p">(),</span> <span class="n">message</span><span class="p">,</span> <span class="n">ec</span><span class="p">)</span>
  <span class="n">ls</span> <span class="o">=</span> <span class="s2">&quot;[</span><span class="si">%s%s</span><span class="s2">WARNING] </span><span class="si">%s</span><span class="s2">&quot;</span> <span class="o">%</span> <span class="p">(</span><span class="n">systools</span><span class="o">.</span><span class="n">now_string</span><span class="p">(),</span> <span class="n">__caller_string</span><span class="p">(),</span> <span class="n">message</span><span class="p">)</span>

  <span class="n">print_message</span><span class="p">(</span><span class="n">os</span><span class="p">,</span> <span class="s2">&quot;warning&quot;</span><span class="p">)</span>
  <span class="n">log_message</span><span class="p">(</span><span class="n">ls</span><span class="p">,</span> <span class="s2">&quot;warning&quot;</span><span class="p">)</span></div>

<div class="viewcode-block" id="error"><a class="viewcode-back" href="../../../d2o.utils.html#d2o.utils.logger.error">[docs]</a><span class="k">def</span> <span class="nf">error</span><span class="p">(</span><span class="n">message</span><span class="p">):</span>
  <span class="n">message</span> <span class="o">=</span> <span class="n">__format_message</span><span class="p">(</span><span class="n">message</span><span class="p">)</span>

  <span class="n">sc</span> <span class="o">=</span> <span class="n">__COLORS</span><span class="o">.</span><span class="n">RED</span> <span class="k">if</span> <span class="p">(</span><span class="n">__SHOW_COLORS</span><span class="p">)</span> <span class="k">else</span> <span class="s1">&#39;&#39;</span>
  <span class="n">ec</span> <span class="o">=</span> <span class="n">__COLORS</span><span class="o">.</span><span class="n">ENDC</span> <span class="k">if</span> <span class="p">(</span><span class="n">__SHOW_COLORS</span><span class="p">)</span> <span class="k">else</span> <span class="s1">&#39;&#39;</span>

  <span class="n">os</span> <span class="o">=</span> <span class="s2">&quot;</span><span class="si">%s</span><span class="s2">[</span><span class="si">%s%s</span><span class="s2">ERROR] </span><span class="si">%s%s</span><span class="s2">&quot;</span> <span class="o">%</span> <span class="p">(</span><span class="n">sc</span><span class="p">,</span> <span class="n">systools</span><span class="o">.</span><span class="n">now_string</span><span class="p">(),</span> <span class="n">__caller_string</span><span class="p">(),</span> <span class="n">message</span><span class="p">,</span> <span class="n">ec</span><span class="p">)</span>
  <span class="n">ls</span> <span class="o">=</span> <span class="s2">&quot;[</span><span class="si">%s%s</span><span class="s2">ERROR] </span><span class="si">%s</span><span class="s2">&quot;</span> <span class="o">%</span> <span class="p">(</span><span class="n">systools</span><span class="o">.</span><span class="n">now_string</span><span class="p">(),</span> <span class="n">__caller_string</span><span class="p">(),</span> <span class="n">message</span><span class="p">)</span>

  <span class="n">print_message</span><span class="p">(</span><span class="n">os</span><span class="p">,</span> <span class="s2">&quot;error&quot;</span><span class="p">)</span>
  <span class="n">log_message</span><span class="p">(</span><span class="n">ls</span><span class="p">,</span> <span class="s2">&quot;error&quot;</span><span class="p">)</span></div>

<div class="viewcode-block" id="fail"><a class="viewcode-back" href="../../../d2o.utils.html#d2o.utils.logger.fail">[docs]</a><span class="k">def</span> <span class="nf">fail</span><span class="p">(</span><span class="n">message</span><span class="p">):</span>
  <span class="n">message</span> <span class="o">=</span> <span class="n">__format_message</span><span class="p">(</span><span class="n">message</span><span class="p">)</span>

  <span class="n">sc</span> <span class="o">=</span> <span class="n">__COLORS</span><span class="o">.</span><span class="n">RED</span> <span class="k">if</span> <span class="p">(</span><span class="n">__SHOW_COLORS</span><span class="p">)</span> <span class="k">else</span> <span class="s1">&#39;&#39;</span>
  <span class="n">ec</span> <span class="o">=</span> <span class="n">__COLORS</span><span class="o">.</span><span class="n">ENDC</span> <span class="k">if</span> <span class="p">(</span><span class="n">__SHOW_COLORS</span><span class="p">)</span> <span class="k">else</span> <span class="s1">&#39;&#39;</span>

  <span class="n">os</span> <span class="o">=</span> <span class="s2">&quot;</span><span class="si">%s</span><span class="s2">[</span><span class="si">%s%s</span><span class="s2">FAIL] </span><span class="si">%s%s</span><span class="s2">&quot;</span> <span class="o">%</span> <span class="p">(</span><span class="n">sc</span><span class="p">,</span> <span class="n">systools</span><span class="o">.</span><span class="n">now_string</span><span class="p">(),</span> <span class="n">__caller_string</span><span class="p">(),</span> <span class="n">message</span><span class="p">,</span> <span class="n">ec</span><span class="p">)</span>
  <span class="n">ls</span> <span class="o">=</span> <span class="s2">&quot;[</span><span class="si">%s%s</span><span class="s2">FAIL] </span><span class="si">%s</span><span class="s2">&quot;</span> <span class="o">%</span> <span class="p">(</span><span class="n">systools</span><span class="o">.</span><span class="n">now_string</span><span class="p">(),</span> <span class="n">__caller_string</span><span class="p">(),</span> <span class="n">message</span><span class="p">)</span>

  <span class="n">print_message</span><span class="p">(</span><span class="n">os</span><span class="p">,</span> <span class="s2">&quot;error&quot;</span><span class="p">)</span>
  <span class="n">log_message</span><span class="p">(</span><span class="n">ls</span><span class="p">,</span> <span class="s2">&quot;error&quot;</span><span class="p">)</span></div>

<span class="c1"># A few aliases</span>
<div class="viewcode-block" id="dbg"><a class="viewcode-back" href="../../../d2o.utils.html#d2o.utils.logger.dbg">[docs]</a><span class="k">def</span> <span class="nf">dbg</span><span class="p">(</span><span class="n">message</span><span class="p">):</span>
  <span class="n">debug</span><span class="p">(</span><span class="n">message</span><span class="p">)</span></div>

<div class="viewcode-block" id="warn"><a class="viewcode-back" href="../../../d2o.utils.html#d2o.utils.logger.warn">[docs]</a><span class="k">def</span> <span class="nf">warn</span><span class="p">(</span><span class="n">message</span><span class="p">):</span>
  <span class="n">warning</span><span class="p">(</span><span class="n">message</span><span class="p">)</span></div>

<div class="viewcode-block" id="err"><a class="viewcode-back" href="../../../d2o.utils.html#d2o.utils.logger.err">[docs]</a><span class="k">def</span> <span class="nf">err</span><span class="p">(</span><span class="n">message</span><span class="p">):</span>
  <span class="n">error</span><span class="p">(</span><span class="n">message</span><span class="p">)</span></div>

<div class="viewcode-block" id="notify"><a class="viewcode-back" href="../../../d2o.utils.html#d2o.utils.logger.notify">[docs]</a><span class="k">def</span> <span class="nf">notify</span><span class="p">(</span><span class="n">message</span><span class="p">):</span>
  <span class="n">info</span><span class="p">(</span><span class="n">message</span><span class="p">)</span></div>

<div class="viewcode-block" id="msg"><a class="viewcode-back" href="../../../d2o.utils.html#d2o.utils.logger.msg">[docs]</a><span class="k">def</span> <span class="nf">msg</span><span class="p">(</span><span class="n">message</span><span class="p">):</span>
  <span class="n">info</span><span class="p">(</span><span class="n">message</span><span class="p">)</span></div>

<div class="viewcode-block" id="progress"><a class="viewcode-back" href="../../../d2o.utils.html#d2o.utils.logger.progress">[docs]</a><span class="k">def</span> <span class="nf">progress</span><span class="p">(</span><span class="n">i</span><span class="p">,</span> <span class="n">total</span><span class="p">,</span> <span class="n">mod</span><span class="o">=</span><span class="mi">100</span><span class="p">):</span>
  <span class="k">if</span> <span class="p">(</span><span class="n">i</span> <span class="o">%</span> <span class="mi">100</span> <span class="o">==</span> <span class="mi">0</span><span class="p">):</span>
    <span class="n">percent_complete</span> <span class="o">=</span> <span class="p">(</span><span class="mi">1</span> <span class="o">-</span> <span class="p">(</span><span class="n">total</span> <span class="o">-</span> <span class="nb">float</span><span class="p">(</span><span class="n">i</span><span class="p">))</span><span class="o">/</span><span class="n">total</span><span class="p">)</span> <span class="o">*</span> <span class="mf">100.0</span>
    <span class="n">info</span><span class="p">(</span><span class="s2">&quot;Percent complete {0:.1f}%&quot;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">percent_complete</span><span class="p">))</span></div>
</pre></div>

           </div>
          </div>
          <footer>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2016, Chronos AS.

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/snide/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  

    <script type="text/javascript">
        var DOCUMENTATION_OPTIONS = {
            URL_ROOT:'../../../',
            VERSION:'1.0',
            COLLAPSE_INDEX:false,
            FILE_SUFFIX:'.html',
            HAS_SOURCE:  true
        };
    </script>
      <script type="text/javascript" src="../../../_static/jquery.js"></script>
      <script type="text/javascript" src="../../../_static/underscore.js"></script>
      <script type="text/javascript" src="../../../_static/doctools.js"></script>
      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>

  

  
  
    <script type="text/javascript" src="../../../_static/js/theme.js"></script>
  

  
  
  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.StickyNav.enable();
      });
  </script>
   

</body>
</html>